-- name: [CS] Dogman Mod
-- description: A hybrid between a dog and a police officer!\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!


local E_MODEL_DOGMAN = smlua_model_util_get_id("DOGMAN_geo")

local TEX_DOGMAN_ICON = get_texture_info("DOGMAN-icon")

local TEXT_MOD_NAME = "DOGMAN"

local VOICETABLE_DOGMAN = {
  --[CHAR_SOUND_OKEY_DOKEY] = 'StartLevel.ogg', -- Starting game
    [CHAR_SOUND_LETS_A_GO] = nil, -- Starting level
    [CHAR_SOUND_OOOF] = 'golpeado.ogg',
    [CHAR_SOUND_OOOF2] = 'golpeado.ogg',
    [CHAR_SOUND_WAH2] = nil,
    [CHAR_SOUND_PUNCH_YAH] =  'golpe-1.ogg', -- Punch 1
    [CHAR_SOUND_PUNCH_WAH] = 'ladrido2.ogg', -- Punch 2
    [CHAR_SOUND_PUNCH_HOO] = 'ladrido1.ogg', -- Punch 3
    [CHAR_SOUND_YAH_WAH_HOO] = {'ladrido1.ogg', 'ladrido2.ogg'}, -- First/Second jump sounds
    [CHAR_SOUND_HOOHOO] = 'ladrido2.ogg', -- Third jump sound
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'ladrido3.ogg', -- Triple jump sounds
    [CHAR_SOUND_UH] = nil, -- Wall bonk
    [CHAR_SOUND_UH2] = nil, -- Landing after long jump
    [CHAR_SOUND_UH2_2] = nil, -- Same sound as UH2; jumping onto ledge
    [CHAR_SOUND_HAHA] = nil, -- Landing triple jump
    [CHAR_SOUND_YAHOO] = 'ladrido3.ogg', -- Long jump
    [CHAR_SOUND_HAHA_2] = nil,
    [CHAR_SOUND_DOH] = 'golpeado.ogg', -- Long jump wall bonk
    [CHAR_SOUND_WHOA] = nil, -- Grabbing ledge
    [CHAR_SOUND_EEUH] = nil, -- Climbing over ledge
    [CHAR_SOUND_WAAAOOOW] = 'caida-o-algo-no-se-xd.ogg', -- Falling a long distance
    [CHAR_SOUND_TWIRL_BOUNCE] = nil, -- Bouncing off of a flower spring
    [CHAR_SOUND_GROUND_POUND_WAH] = nil, 
    [CHAR_SOUND_HRMM] = 'victoria.ogg', -- Lifting something
    [CHAR_SOUND_HERE_WE_GO] = 'victoria.ogg', -- Star get
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'victoria.ogg', -- Throwing Bowser
--DAMAGE
    [CHAR_SOUND_ATTACKED] = 'golpeado.ogg', -- Damaged
    [CHAR_SOUND_PANTING] = nil, -- Low health
    [CHAR_SOUND_ON_FIRE] = 'golpeado.ogg', -- Burned
--SLEEP SOUNDS
    [CHAR_SOUND_IMA_TIRED] = nil, -- Mario feeling tired
    [CHAR_SOUND_YAWNING] = nil, -- Mario yawning before he sits down to sleep
    [CHAR_SOUND_SNORING1] = nil, -- Snore Inhale
    [CHAR_SOUND_SNORING2] = nil, -- Exhale
    [CHAR_SOUND_SNORING3] = nil, -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
    [CHAR_SOUND_COUGHING1] = nil, -- Cough take 1
    [CHAR_SOUND_COUGHING2] = nil, -- Cough take 2
    [CHAR_SOUND_COUGHING3] = nil, -- Cough take 3
--DEATH
    [CHAR_SOUND_DYING] = 'caida-o-algo-no-se-xd.ogg', -- Dying from damage
    [CHAR_SOUND_DROWNING] = nil, -- Running out of air underwater
    [CHAR_SOUND_MAMA_MIA] = nil -- Booted out of level
}

local PALETTE_DOGMAN = {
    [PANTS]  = "0F2B6C",
    [SHIRT]  = "4454C6",
    [GLOVES] = "FFFFFF",
    [SHOES]  = "432316",
    [HAIR]   = "FFAD25",
    [SKIN]   = "E89345",
    [CAP]    = "FFDD51",
	}
	
--[[ PaRappa does NOT take his hat off under ANY circumstances, as canonically, hatless PaRappa is a horrid sight.
local CAPTABLE_PARAPPA = {
    normal = smlua_model_util_get_id("parappa_cap_normal_geo"),
    wing = smlua_model_util_get_id("parappa_cap_wing_geo"),
    metal = smlua_model_util_get_id("parappa_cap_metal_geo"),
    metalWing = smlua_model_util_get_id("parappa_cap_wing_geo"),
}
--]]

if _G.charSelectExists then
    CT_CHAR = _G.charSelect.character_add("Dogman", "a hybrid between a dog and a police officer!", "Made by @Asplatim on twitter", {r = 197, g = 151, b = 86}, E_MODEL_DOGMAN, CT_MARIO, TEX_DOGMAN_ICON)
--      _G.charSelect.character_add_caps(E_MODEL_PARAPPA, CAPTABLE_PARAPPA)
    _G.charSelect.character_add_palette_preset(E_MODEL_DOGMAN, PALETTE_DOGMAN)
     --the following must be hooked for each character added

    _G.charSelect.character_add_voice(E_MODEL_DOGMAN, VOICETABLE_DOGMAN)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_DOGMAN then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_DOGMAN then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end